
# .equ SPL = 0x3d
# .equ SPH = 0x3e

# void marte_hal_jump_to_context(uint16 *new_task_body_address,
#                                uint16 *stack_top)
#           new_task_body_address -> r25:24
#           stack_top             -> r23:22
.globl marte_hal_jump_to_context

marte_hal_jump_to_context:
  # load jump address in r31:r30 (Z reg)
  mov r31, r25
  mov r30, r24

  # load new stack top
  # SPL = 0x3d
  out 0x3d, r22
  # SPH = 0x3e
  out 0x3e, r23

  # Jump to the task body using icall
  # icall ; Call routine pointed to by r31:r30
  icall
